code_start = $1001

.org code_start-2
	.word code_start; for the .prg file

;BASIC:	 2003 sys4109

	.word :+,2003
	.byte $9e	; sys token
	.byte "4109"
:	.byte 0,0,0


.proc	main

	sei
	sta $ff3f

	lda #0
	sta $ff15
	sta $ff19

	jsr copyFliData

	jsr initMem
	jsr startFli

c:	jmp c

.endproc


gr_mode_06 = $38
gr_mode_07 = $18

sc00 = $40
sc10 = $48
sc20 = $50
sc30 = $58
sc01 = $60
sc11 = $68
sc21 = $70
sc31 = $78

screens0:
	.byte sc11,sc20,sc31,sc00
screens1:
	.byte sc10,sc21,sc30,sc01
yscroll:
	.byte gr_mode_06 + 5
	.byte gr_mode_06 + 7
	.byte gr_mode_06 + 1
	.byte gr_mode_06 + 3

xscroll0:
xscroll1 = xscroll0 + 1
	.byte 0,2,0,2,0


.proc	startFli

	lda #<irq
	sta $fffe
	lda #>irq
	sta $ffff
	lda #2
	sta $ff0a
	sta $ff0b
	lda $ff09
	sta $ff09

	lda #$20
	sta $ff12

	cli
	rts

irq:
	sta tempa

	lda $ff1e
	and #4
	beq cont
cont:
	lda $ff09
	sta $ff09
	inc $ff0b
	lda #<timed
	sta $fffe
	cli
	stx tempx
	sty tempy
	ldx #0

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
tempa = *+1
	lda #0
tempx = *+1
	ldx #0
tempy = *+1
	ldy #0
	rti


timed = flic+5
flic:
	cmp #$c9
	cmp #$c9
	cmp $ea

	txa
	and #3
	tay

l07:	lda xscroll0,y
	sta $ff07
l14:	lda screens0,y
	sta $ff14
	lda yscroll,y
	sta $ff06
	inx
	cpx #100
	bne flic

	lda l07+1
	eor #((<xscroll0) ^ (<xscroll1))
	sta l07+1
	lda l14+1
	eor #((<screens0) ^ (<screens1))
	sta l14+1

	dec $ff0b
	lda #<irq
	sta $fffe
	lda $ff09
	sta $ff09
	rti

.endproc


.proc	copyFliData

	lda #<fliData
	sta $d0
	lda #($3f + >fliData)
	sta $d1
	ldy #0
	sty $d2
	lda #$7f
	sta $d3
	ldx #$40
l:	lda ($d0),y
	sta ($d2),y
	iny
	bne l
	dec $d1
	dec $d3
	dex
	bne l
	rts
.endproc


.proc	initMem

	ldx #4

	lda $ff07
	and #$40
	ora #gr_mode_07
:	sta xscroll0,x
	eor #2

	dex
	bpl :-

	ldy #0
	sty $d0
	lda #$80
	sta $d1
	ldx #$20
	lda #$48
l:
	sta ($d0),y
	iny
	bne l
	inc $d1
	dex
	bne l

	rts

.endproc


fliData: